VERSION 2.00
Begin Form BFDemo 
   BackColor       =   &H00FFFFFF&
   Caption         =   "BeautiFonts Demo.  Copyright 1995 Brian Reed, All Rights Reserved."
   ClientHeight    =   6510
   ClientLeft      =   45
   ClientTop       =   630
   ClientWidth     =   9495
   Height          =   7200
   Left            =   -15
   LinkTopic       =   "BFDemo"
   ScaleHeight     =   434
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   633
   Top             =   0
   Width           =   9615
   Begin Image CastleImage 
      Height          =   495
      Left            =   20000
      Picture         =   BFDEMO.FRX:0000
      Top             =   10000
      Width           =   495
   End
   Begin Image FlockImage 
      Height          =   810
      Left            =   20000
      Picture         =   BFDEMO.FRX:02DA
      Top             =   9000
      Width           =   840
   End
   Begin Menu BF_ABOUT 
      Caption         =   "&About "
      Begin Menu BF_ABOUT_MSG 
         Caption         =   "&About BeautiFonts"
      End
   End
   Begin Menu BF_LOOP
      Caption         =   "&Loop Tests "
      Begin Menu BF_BMF_LOOPTEST 
         Caption         =   "&BMF Loop Test  "
      End
      Begin Menu BF_TT_LOOPTEST 
         Caption         =   "&TT Loop Test  "
      End
      Begin Menu BF_TT_LOOPBOTH 
         Caption         =   "&Loop Both  "
      End
   End
   Begin Menu BF_BMF 
      Caption         =   "&BMF Tests "
      Begin Menu BF_BMF_RGB 
         Caption         =   "&RGB Test  "
      End
      Begin Menu BF_BMF_TEXT 
         Caption         =   "&Text Test  "
      End
      Begin Menu BF_BMF_BOX 
         Caption         =   "&Box Test  "
      End
      Begin Menu BF_BMF_FROST 
         Caption         =   "&Frost Test "
      End
   End
   Begin Menu BF_TT 
      Caption         =   "&TrueType Tests "
      Begin Menu BF_TT_RGB 
         Caption         =   "&RGB Test  "
      End
      Begin Menu BF_TT_SHOWALL 
         Caption         =   "&Show All  "
      End
      Begin Menu BF_TT_ALPHA 
         Caption         =   "&Alphabet Test  "
      End
      Begin Menu BF_TT_COMPARE 
         Caption         =   "&Comparison Test "
      End
      Begin Menu BF_TT_LARGE 
         Caption         =   "&Large Test "
      End
   End
   Begin Menu BF_CUSTOM 
      Caption         =   "&Custom Test "
      Begin Menu BF_CUSTOMTEST 
         Caption         =   "&Custom Text  "
      End
   End
   Begin Menu BF_GRAPHICS 
      Caption         =   "&Graphics Test "
      Begin Menu BF_RECTTEST 
         Caption         =   "&Rectangle Test  "
      End
   End
End
Option Explicit
DefInt A-Z

Sub BF_ABOUT_MSG_Click ()

  Dim i%, j%, hdc%, hMyFont%, hfOld%, x%, y%
  Dim logf As LOGFONT
  ReDim Text(0 To 16) As String
  Text(0) = "This is a demo of my Windows DLL anti-aliased font engine.  Anti-aliased fonts"
  Text(1) = "are used to reduce the 'jaggies' that appear in standard monochrome fonts."
  Text(2) = "Be sure to try the TrueType 'Comparison Test' for a side-by-side view."
  Text(3) = ""
  Text(4) = "For best viewing, run this demo at a resolution of 640x480 in an RGB display"
  Text(5) = "mode (32768, 65536 or 16 million colors).  256 color modes usually work,"
  Text(6) = "depending on the driver."
  Text(7) = ""
  Text(8) = "The purpose of this demo is to evaluate user interest towards a potential"
  Text(9) = "product and all feedback is appreciated.  My font engine also has unfinished"
  Text(10) = "DOS and Grasp libraries."
  Text(11) = ""
  Text(12) = "Next on my to-do list are a few cleanup's, speed optimizations, and underlines."
  Text(13) = "This screen is not anti-aliased."
  Text(14) = ""
  Text(15) = ""
  Text(16) = "Brian Reed  29328 Fairfield  Warren, MI  48093   73503.3364@compuserve.com"

  x = 26
  y = 30

  ' Get somewhere to draw to
  hdc = GetDC(BFDEMO.hWnd)
  If hdc = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't get an HDC.", "No HDC", MB_OK)
    Exit Sub
  End If
  Screen.MousePointer = 11
  BackgroundDraw hdc, 3

  '  Print using regular TrueType font.
  i = APIGetObject(GetStockObject(SYSTEM_FONT), Len(logf), logf)
  logf.lfHeight = 20
  logf.lfWidth = 0
  logf.lfEscapement = 0
  logf.lfOrientation = 0
  logf.lfWeight = FW_LIGHT
  logf.lfItalic = Chr(0)
  logf.lfUnderline = Chr(0)
  logf.lfStrikeOut = Chr(0)
  logf.lfCharSet = Chr(0)
  logf.lfOutPrecision = Chr(0)
  logf.lfClipPrecision = Chr(0)
  logf.lfQuality = Chr(0)
  logf.lfPitchAndFamily = Chr(0)
  logf.lfFaceName = Mid$("Times New Roman", 1)
  hMyFont = 0
  hMyFont = CreateFontIndirect(logf)
  If hMyFont <> 0 Then
    hfOld = SelectObject(hdc, hMyFont)
    For i = 0 To 16
      j = TextOut(hdc, x, y, Text(i), Len(Text(i)))
      y = y + logf.lfHeight
    Next i
    hfOld = SelectObject(hdc, hfOld)
    i = DeleteObject(hMyFont)
  Else
    i = MessageBox(BFDEMO.hWnd, "Couldn't open Times New Roman", "Error", MB_OK)
  End If

  Screen.MousePointer = 1
  ReleaseDC BFDEMO.hWnd, hdc

End Sub

Sub BF_BMF_BOX_Click ()

  BMF_Box

End Sub

Sub BF_BMF_FROST_Click ()

  BMF_Frost

End Sub

Sub BF_BMF_LOOPTEST_Click ()

  BMF_RGB
  BMF_Text
  BMF_Box
  BMF_Frost

End Sub

Sub BF_BMF_RGB_Click ()

  BMF_RGB

End Sub

Sub BF_BMF_TEXT_Click ()

  BMF_Text

End Sub

Sub BF_CUSTOMTEST_Click ()

  TT_Custom

End Sub

Sub BF_RECTTEST_Click ()

  Dim i%, hdc%, x1%, x2%, y1%, y2%
  Dim bm&

  x1 = 25
  x2 = 615
  y1 = 54
  y2 = 104

  ' Get somewhere to draw to
  hdc = GetDC(BFDEMO.hWnd)
  If hdc = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't get an HDC.", "No HDC", MB_OK)
    Exit Sub
  End If
  Screen.MousePointer = 11
  bm = bfSetBitMap(bfSTATE, hdc)
  BackgroundDraw hdc, 2

  bfGfxRect bfTRANS + (100 * 256), bfBACKSOLID, 0, bfCYAN, 0, x1, y1, x2, y2
  y1 = y1 + 70
  y2 = y2 + 70
  bfGfxRect bfTRANS + (100 * 256), bfBACKSOLID, 0, bfBLACK, 0, x1, y1, x2, y2
  y1 = y1 + 70
  y2 = y2 + 70
  bfGfxRect bfPUT, bfBACKBORDER, 2, bfCYAN, 0, x1, y1, x2, y2
  y1 = y1 + 73
  y2 = y2 + 77
  bfGfxRect bfTRANS + (90 * 256), bfBACKBORDER, 5, bfBLACK, 0, x1, y1, x2, y2

  Screen.MousePointer = 1
  ReleaseDC BFDEMO.hWnd, hdc

End Sub

Sub BF_TT_ALPHA_Click ()

  TT_Alpha

End Sub

Sub BF_TT_COMPARE_Click ()

  TT_Compare

End Sub

Sub BF_TT_LARGE_Click ()

  TT_Large

End Sub

Sub BF_TT_LOOPBOTH_Click ()

  BMF_RGB
  BMF_Text
  BMF_Box
  BMF_Frost
  TT_RGB
  TT_ShowAll
  TT_Alpha
  TT_Compare
  TT_Large

End Sub

Sub BF_TT_LOOPTEST_Click ()

  TT_RGB
  TT_ShowAll
  TT_Alpha
  TT_Compare
  TT_Large

End Sub

Sub BF_TT_RGB_Click ()

  TT_RGB

End Sub

Sub BF_TT_SHOWALL_Click ()

  TT_ShowAll

End Sub

Sub Form_Load ()

  Dim i%

  ChDir App.Path
  'ChDrive App.Drive   ' How to ensure drive setting to find a local DLL?
  i = bfInit(bf24BIT)

End Sub

Sub Form_Unload (Cancel As Integer)

  bfEnd

End Sub

