Option Explicit
DefInt A-Z

Sub BackgroundDraw (ByVal hdc%, ByVal style%)
  
Dim i%, x%, y%, memdc%, oldhbm%
Dim foreclr&

  ' Draw a FLOCK background
  If style = 1 Then
    memdc = CreateCompatibleDC(hdc)
    If memdc <> 0 Then
      oldhbm = SelectObject(memdc, BFDEMO!FlockImage)
      If oldhbm <> 0 Then
        For x = 0 To BFDEMO.ScaleWidth Step BFDEMO!FlockImage.Width
          For y = 0 To BFDEMO.ScaleHeight Step BFDEMO!FlockImage.Height
            i = BitBlt(hdc, x, y, BFDEMO!FlockImage.Width, BFDEMO!FlockImage.Height, memdc, 0, 0, SRCCOPY)
          Next y
        Next x
        oldhbm = SelectObject(memdc, oldhbm)
      End If
      i = DeleteDC(memdc)
    End If
  End If

  ' Draw a CASTLE background
  If style = 2 Then
    memdc = CreateCompatibleDC(hdc)
    If memdc <> 0 Then
      oldhbm = SelectObject(memdc, BFDEMO!CastleImage)
      If oldhbm <> 0 Then
        For x = 0 To BFDEMO.ScaleWidth Step BFDEMO!CastleImage.Width
          For y = 0 To BFDEMO.ScaleHeight Step BFDEMO!CastleImage.Height
            i = BitBlt(hdc, x, y, BFDEMO!CastleImage.Width, BFDEMO!CastleImage.Height, memdc, 0, 0, SRCCOPY)
          Next y
        Next x
        oldhbm = SelectObject(memdc, oldhbm)
      End If
      i = DeleteDC(memdc)
    End If
  End If

  ' Draw a white rectangle
  If style = 3 Then
    BFDEMO.DrawWidth = 1
    foreclr = BFDEMO.ForeColor
    BFDEMO.ForeColor = &HFFFFFF
    BFDEMO.Line (0, 0)-(BFDEMO.ScaleWidth, BFDEMO.ScaleHeight), , BF
    BFDEMO.ForeColor = foreclr
  End If

  ' Draw a white rectangle
  If style = 4 Then
    BFDEMO.DrawWidth = 1
    foreclr = BFDEMO.ForeColor
    BFDEMO.ForeColor = &H404040
    BFDEMO.Line (0, 0)-(BFDEMO.ScaleWidth, BFDEMO.ScaleHeight), , BF
    BFDEMO.ForeColor = foreclr
  End If

End Sub

Sub BMF_Box ()

  Dim hdc%, Xcenter%, i%
  Dim bmf&
  Dim state&

  Xcenter = 320

  ' Get somewhere to draw to
  hdc = GetDC(BFDEMO.hWnd)
  If hdc = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't get an HDC.", "No HDC", MB_OK)
    Exit Sub
  End If
  state = bfSetBitMap(bfSTATE, hdc)
  Screen.MousePointer = 11
  BackgroundDraw hdc, 1
  
  ' Open font file
  bmf = bfActOpen("ARIAL032.BMF")
  If bmf = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't open the 1st font file.", "Not Found", MB_OK)
  Else
    state = bfSetFont(bfSTATE, bmf)
    state = bfSetColors(bfSTATE, 48, 0, bfWHITE, bfCYAN, 1, bfBETA, bfGAMMA)
    state = bfSetDrawMode(bfSTATE, bfBLEND + bfTRANS, 128)
    state = bfSetUnderline(bfSTATE, 3, 3)
    state = bfSetJust(bfSTATE, bfHCENTER, bfVTOP)
    state = bfSetBackMode(bfSTATE, bfPUT, 0)
    state = bfSetBackStyle(bfSTATE, bfBACKSOLID, 1)
    state = bfSetBackSize(bfSTATE, 0, 0, 0, 0)
    state = bfSetFace(bfSTATE, bfNORMAL)
    state = bfSetDrawMode(bfSTATE, bfBLEND, 0)
    state = bfStrDraw(bfSTATE, Xcenter, 10, "Solid text color here")
    state = bfSetFace(bfSTATE, bfUNDER)
    state = bfSetDrawMode(bfSTATE, bfTRANS, 110)
    state = bfStrDraw(bfSTATE, Xcenter, 44, "Transparent, with underline")
    state = bfSetFace(bfSTATE, bfDROP)
    state = bfSetDropMode(bfSTATE, bfTRANS, 110)
    state = bfSetDrawMode(bfSTATE, bfBLEND, 0)
    state = bfSetDropColors(bfSTATE, 145, bfCYAN, bfCYAN, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, Xcenter, 84, "Transparent cyan dropshadow")
    state = bfSetBackMode(bfSTATE, bfTRANS, 0)
    state = bfSetDropMode(bfSTATE, bfBLEND, 0)
    state = bfSetDropColors(bfSTATE, 220, bfBLACK, bfCYAN, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, Xcenter, 124, "0% background test")
    state = bfSetBackMode(bfSTATE, bfTRANS, 64)
    state = bfSetBackStyle(bfSTATE, bfBACKBORDER, 1)
    state = bfSetBackSize(bfSTATE, 35, 10, 35, 10)
    state = bfSetFace(bfSTATE, bfBACK)
    state = bfSetDrawMode(bfSTATE, bfBLEND, 0)
    state = bfStrDraw(bfSTATE, Xcenter, 180, "25% back, border 1.  Back bytes >64K.  j")
    state = bfSetFace(bfSTATE, bfUNDER + bfBACK)
    state = bfSetBackMode(bfSTATE, bfTRANS, 128)
    state = bfSetBackStyle(bfSTATE, bfBACKSOLID, 1)
    state = bfSetBackSize(bfSTATE, 35, 10, 0, 0)
    state = bfSetDrawMode(bfSTATE, bfTRANS, 120)
    state = bfStrDraw(bfSTATE, Xcenter, 240, "50% back, with underline.  j")
    state = bfSetFace(bfSTATE, bfDROP + bfBACK + bfUNDER)
    state = bfSetBackMode(bfSTATE, bfTRANS, 160)
    state = bfSetBackStyle(bfSTATE, bfBACKSOLID, 1)
    state = bfSetBackSize(bfSTATE, 0, 0, 35, 10)
    state = bfSetDropMode(bfSTATE, bfTRANS, 85)
    state = bfSetDrawMode(bfSTATE, bfBLEND, 0)
    state = bfSetDropColors(bfSTATE, 160, bfBLUE, bfCYAN, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, Xcenter, 290, "60% background.  j")
    state = bfSetFace(bfSTATE, bfDROP + bfBACK)
    state = bfSetBackMode(bfSTATE, bfTRANS, 255)
    state = bfSetBackStyle(bfSTATE, bfBACKBORDER, 2)
    state = bfSetBackSize(bfSTATE, 20, 10, 20, 10)
    state = bfSetDropMode(bfSTATE, bfBLEND, 0)
    state = bfSetDropColors(bfSTATE, 240, bfBLACK, bfCYAN, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, Xcenter, 360, "100% back, border 2.  j")
    state = bfSetJust(bfSTATE, bfHLEFT, bfVBASE)
    state = bfSetFace(bfSTATE, bfNORMAL)
    state = bfSetBackMode(bfSTATE, bfPUT, 0)
    state = bfSetBackStyle(bfSTATE, bfBACKSOLID, 1)
    state = bfSetBackSize(bfSTATE, 0, 0, 0, 0)
    i = bfActClose(bmf)
  End If

  Screen.MousePointer = 1
  ' Ah, protect the environment...  catch him in sport, and let 'im free.  :)
  ReleaseDC BFDEMO.hWnd, hdc

End Sub

Sub BMF_Frost ()

  Dim hdc%
  Dim i%
  Dim fnt1&
  Dim strng&
  Dim state&
  Dim Xleft%

  Xleft = 20

  ' Get somewhere to draw to
  hdc = GetDC(BFDEMO.hWnd)
  If hdc = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't get an HDC.", "No HDC", MB_OK)
    Exit Sub
  End If
  state = bfSetBitMap(bfSTATE, hdc)
  Screen.MousePointer = 11
  BackgroundDraw hdc, 3
  
  ' Open font file
  fnt1 = bfActOpen("ARIAL032.BMF")
  If fnt1 = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't open the 1st font file.", "Not Found", MB_OK)
  Else
    state = bfSetDrawMode(bfSTATE, bfBLEND, 0)
    state = bfSetColors(bfSTATE, 48, 0, &HA05050, bfWHITE, 1, bfBETA, bfGAMMA)
    strng = bfStrDraw(bfSTATE, Xleft, 90, "Why make so much of fragmentary blue")
    strng = bfStrDraw(bfSTATE, Xleft, 140, "In here or there a bird, or butterfly,")
    strng = bfStrDraw(bfSTATE, Xleft, 190, "Or flower, or wearing stone, or open eye")
    strng = bfStrDraw(bfSTATE, Xleft, 240, "When heaven presents in sheets the solid hue?")
    strng = bfStrDraw(bfSTATE, Xleft + 300, 310, "> Robert Frost")
    i = bfActClose(fnt1)
  End If

  Screen.MousePointer = 1
  ' Ah, protect the environment...  catch him in sport, and let 'im free.  :)
  ReleaseDC BFDEMO.hWnd, hdc

End Sub

Sub BMF_RGB ()

  Dim hdc%
  Dim i%
  Dim bmf&
  Dim state&

  ' Get somewhere to draw to
  hdc = GetDC(BFDEMO.hWnd)
  If hdc = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't get an HDC.", "No HDC", MB_OK)
    Exit Sub
  End If
  state = bfSetBitMap(bfSTATE, hdc)
  Screen.MousePointer = 11
  BackgroundDraw hdc, 1
  
  ' Open font file
  bmf = bfActOpen("ARIAL032.BMF")
  If bmf = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't open the 1st font file.", "Not Found", MB_OK)
  Else
    state = bfSetFont(bfSTATE, bmf)
    state = bfSetDrawMode(bfSTATE, bfBLEND, 255)
    state = bfSetColors(bfSTATE, 0, 0, bfWHITE, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 190, 45, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfLIGHTGRAY, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 190, 80, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfGRAY, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 190, 115, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfDARKGRAY, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 190, 150, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfBLACK, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 190, 185, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfRED, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 190, 220, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfGREEN, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 190, 255, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfBLUE, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 190, 290, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfYELLOW, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 190, 325, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfCYAN, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 190, 360, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfPURPLE, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 190, 395, "Text Line For Test!")
    i = bfActClose(bmf)
  End If

  Screen.MousePointer = 1
  ' Ah, protect the environment...  catch him in sport, and let 'im free.  :)
  ReleaseDC BFDEMO.hWnd, hdc

End Sub

Sub BMF_Text ()

  Dim hdc%
  Dim i%
  Dim fnt1&, fnt2&, fnt3&
  Dim state&

  ' Get somewhere to draw to
  hdc = GetDC(BFDEMO.hWnd)
  If hdc = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't get an HDC.", "No HDC", MB_OK)
    Exit Sub
  End If
  state = bfSetBitMap(bfSTATE, hdc)
  Screen.MousePointer = 11
  BackgroundDraw hdc, 1

  ' Open 3 font files
  fnt1 = bfActOpen("ARIAL032.BMF")
  If fnt1 = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't open the 1st font file.", "Not Found", MB_OK)
  End If
  fnt2 = bfActOpen("ARIIT032.BMF")
  If fnt2 = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't open the 2nd font file.", "Not Found", MB_OK)
  End If
  fnt3 = bfActOpen("ARIB1032.BMF")
  If fnt3 = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't open the 3rd font file.", "Not Found", MB_OK)
  End If

  ' Draw text with the 3 fonts
  If fnt1 <> 0 Then
    state = bfSetFont(bfSTATE, fnt1)
    state = bfSetColors(bfSTATE, 48, 0, bfWHITE, bfDARKGRAY, 1, bfBETA, bfGAMMA)
    state = bfSetDrawMode(bfSTATE, bfPUT, 128)
    state = bfStrDraw(bfSTATE, 60, 50, "This is (the fastest) PUT mode of text")
    i = bfActClose(fnt1)
  End If
  If fnt2 <> 0 Then
    state = bfSetFont(bfSTATE, fnt2)
    state = bfSetDrawMode(bfSTATE, bfBLEND, 128)
    state = bfSetColors(bfSTATE, 48, 0, bfWHITE, bfBLACK, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 60, 120, "This is just a plain old test of text,")
    state = bfSetColors(bfSTATE, 48, 0, bfRED, bfBLACK, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 60, 160, "using BLEND mode.  BLEND offers no ")
    state = bfSetColors(bfSTATE, 48, 0, bfGREEN, bfBLACK, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 60, 200, "transparency, but is fastest when the")
    state = bfSetColors(bfSTATE, 48, 0, bfBLUE, bfBLACK, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 60, 240, "background is not solid.  Edges are")
    state = bfSetColors(bfSTATE, 48, 0, bfWHITE, bfBLACK, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 60, 280, "blended for best anti-aliased quality.")
    i = bfActClose(fnt2)
  End If
  If fnt3 <> 0 Then
    state = bfSetFont(bfSTATE, fnt3)
    state = bfSetDrawMode(bfSTATE, bfTRANS, 110)
    state = bfSetColors(bfSTATE, 48, 0, bfWHITE, bfBLACK, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 60, 340, "Now we've moved into TRANS mode,")
    state = bfSetColors(bfSTATE, 48, 0, bfCYAN, bfBLACK, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 60, 380, "so that we can see the slowdown")
    state = bfSetColors(bfSTATE, 48, 0, bfWHITE, bfBLACK, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 60, 420, "associated with the extra work.")
    i = bfActClose(fnt3)
  End If

  Screen.MousePointer = 1

  ' Ah, protect the environment...  catch him in sport, and let 'im free.  :)
  ReleaseDC BFDEMO.hWnd, hdc

End Sub

Sub TT_Alpha ()

  Dim hdc%, errval%, i%, mypoints%
  Dim bmf&, state&
  Dim logf As LOGFONT
  
  ' Get somewhere to draw to
  hdc = GetDC(BFDEMO.hWnd)
  If hdc = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't get an HDC.", "No HDC", MB_OK)
    Exit Sub
  End If
  state = bfSetBitMap(bfSTATE, hdc)
  Screen.MousePointer = 11
  BackgroundDraw hdc, 1
  
  ' Do first font file
  i = APIGetObject(GetStockObject(SYSTEM_FONT), Len(logf), logf)
  mypoints = 42
  logf.lfHeight = -MulDiv(mypoints * 4, GetDeviceCaps(hdc, LOGPIXELSY), 72)
  logf.lfWidth = 0
  logf.lfWeight = FW_LIGHT
  logf.lfFaceName = "Times New Roman" + Chr$(0)
  bmf = bfActOpenTT(hdc, logf, "", bfBOTH)
  
  state = bfSetFont(bfSTATE, bmf)
  If bmf = 0 Then
    errval = bfGetError(bfCLEAR)
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't open the font file.", "Error = " + Str$(errval), MB_OK)
  Else
    state = bfSetFont(bfSTATE, bmf)
    state = bfSetDrawMode(bfSTATE, bfBLEND, 255)
    state = bfSetColors(bfSTATE, 0, 0, bfWHITE, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 86, 45, "ABCDEFGHIJKLM")
    state = bfStrDraw(bfSTATE, 86, 90, "NOPQRSTUVWXYZ")
    state = bfStrDraw(bfSTATE, 86, 140, "abcdefghijklm")
    state = bfStrDraw(bfSTATE, 86, 185, "nopqrstuvwxyz")
    i = bfActClose(bmf)
  End If

  ' Do second font file
  i = APIGetObject(GetStockObject(SYSTEM_FONT), Len(logf), logf)
  mypoints = 44
  logf.lfHeight = -MulDiv(mypoints * 4, GetDeviceCaps(hdc, LOGPIXELSY), 72)
  logf.lfWidth = 0
  logf.lfWeight = FW_LIGHT
  logf.lfItalic = Chr(1)
  logf.lfFaceName = "Times New Roman" + Chr$(0)
  bmf = bfActOpenTT(hdc, logf, "", bfBOTH)
  
  state = bfSetFont(bfSTATE, bmf)
  If bmf = 0 Then
    errval = bfGetError(bfCLEAR)
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't open the font file.", "Error = " + Str$(errval), MB_OK)
  Else
    state = bfSetFont(bfSTATE, bmf)
    state = bfSetDrawMode(bfSTATE, bfTRANS, 120)
    state = bfSetColors(bfSTATE, 0, 0, bfWHITE, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 86, 240, "ABCDEFGHIJKLM")
    state = bfStrDraw(bfSTATE, 86, 295, "NOPQRSTUVWXYZ")
    state = bfStrDraw(bfSTATE, 86, 350, "abcdefghijklm")
    state = bfStrDraw(bfSTATE, 86, 405, "nopqrstuvwxyz")
    i = bfActClose(bmf)
  End If

  Screen.MousePointer = 1
  ' Ah, protect the environment...  catch him in sport, and let 'im free.  :)
  ReleaseDC BFDEMO.hWnd, hdc

End Sub

Sub TT_Compare ()

  Dim hdc%, i%, hfOld%, hMyFont%
  Dim bmf&, state&
  Dim logf As LOGFONT
  
  ' Get somewhere to draw to
  hdc = GetDC(BFDEMO.hWnd)
  If hdc = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't get an HDC.", "No HDC", MB_OK)
    Exit Sub
  End If
  state = bfSetBitMap(bfSTATE, hdc)
  Screen.MousePointer = 11
  BackgroundDraw hdc, 3
  
  state = bfSetColors(bfSTATE, 0, 0, bfBLACK, bfWHITE, 1, bfBETA, bfGAMMA)
  state = bfSetDrawMode(bfSTATE, bfBLEND, 255)

  ' Print the regular TrueType font.
  BFDEMO.ForeColor = &H0
  logf.lfHeight = -MulDiv(36, GetDeviceCaps(hdc, LOGPIXELSY), 72)
  logf.lfWidth = 0
  logf.lfItalic = Chr(1)
  logf.lfWeight = FW_DONTCARE
  logf.lfFaceName = "Times New Roman" + Chr$(0)
  hMyFont = CreateFontIndirect(logf)
  If hMyFont <> 0 Then
    hfOld = SelectObject(hdc, hMyFont)
    i = TextOut(hdc, 20, 30, "1- This is a sample for testing", 31)
    hfOld = SelectObject(hdc, hfOld)
    i = DeleteObject(hMyFont)
  Else
    i = MessageBox(BFDEMO.hWnd, "Couldn't open font", "Error", MB_OK)
  End If

  ' Do the anti-aliased sample.
  logf.lfHeight = -MulDiv(36 * 4, GetDeviceCaps(hdc, LOGPIXELSY), 72)
  logf.lfWidth = 0
  logf.lfItalic = Chr(1)
  logf.lfWeight = FW_DONTCARE
  logf.lfFaceName = "Times New Roman" + Chr$(0)
  bmf = bfActOpenTT(hdc, logf, "", bfBOTH)
  If bmf <> 0 Then
    state = bfStrDraw(bfSTATE, 20, 130, "1- This is a sample for testing")
    i = bfActClose(bmf)
  Else
    i = MessageBox(BFDEMO.hWnd, "Couldn't open font", "Error", MB_OK)
  End If

  ' Print the regular TrueType font.
  BFDEMO.ForeColor = &H0
  logf.lfHeight = -MulDiv(36, GetDeviceCaps(hdc, LOGPIXELSY), 72)
  logf.lfWidth = 0
  logf.lfItalic = Chr(0)
  logf.lfWeight = FW_DONTCARE
  logf.lfFaceName = "Times New Roman" + Chr$(0)
  hMyFont = CreateFontIndirect(logf)
  If hMyFont <> 0 Then
    hfOld = SelectObject(hdc, hMyFont)
    i = TextOut(hdc, 20, 160, "1- This is a sample for testing", 31)
    hfOld = SelectObject(hdc, hfOld)
    i = DeleteObject(hMyFont)
  Else
    i = MessageBox(BFDEMO.hWnd, "Couldn't open font", "Error", MB_OK)
  End If

  ' Do the anti-aliased sample.
  logf.lfHeight = -MulDiv(36 * 4, GetDeviceCaps(hdc, LOGPIXELSY), 72)
  logf.lfWidth = 0
  logf.lfItalic = Chr(0)
  logf.lfWeight = FW_DONTCARE
  logf.lfFaceName = "Times New Roman" + Chr$(0)
  bmf = bfActOpenTT(hdc, logf, "", bfBOTH)
  If bmf <> 0 Then
    state = bfStrDraw(bfSTATE, 20, 260, "1- This is a sample for testing")
    i = bfActClose(bmf)
  Else
    i = MessageBox(BFDEMO.hWnd, "Couldn't open font", "Error", MB_OK)
  End If

  ' Print the regular TrueType font.
  BFDEMO.ForeColor = &H0
  logf.lfHeight = -MulDiv(15, GetDeviceCaps(hdc, LOGPIXELSY), 72)
  logf.lfWidth = 0
  logf.lfItalic = Chr(1)
  logf.lfWeight = FW_DONTCARE
  logf.lfFaceName = "Times New Roman" + Chr$(0)
  hMyFont = CreateFontIndirect(logf)
  If hMyFont <> 0 Then
    hfOld = SelectObject(hdc, hMyFont)
    i = TextOut(hdc, 40, 300, "3- This is a sample for testing", 31)
    hfOld = SelectObject(hdc, hfOld)
    i = DeleteObject(hMyFont)
  Else
    i = MessageBox(BFDEMO.hWnd, "Couldn't open font", "Error", MB_OK)
  End If

  ' Do the anti-aliased sample.
  logf.lfHeight = -MulDiv(15 * 4, GetDeviceCaps(hdc, LOGPIXELSY), 72)
  logf.lfWidth = 0
  logf.lfItalic = Chr(1)
  logf.lfWeight = FW_DONTCARE
  logf.lfFaceName = "Times New Roman" + Chr$(0)
  bmf = bfActOpenTT(hdc, logf, "", bfBOTH)
  If bmf <> 0 Then
    state = bfStrDraw(bfSTATE, 40, 340, "3- This is a sample for testing")
    i = bfActClose(bmf)
  Else
    i = MessageBox(BFDEMO.hWnd, "Couldn't open font", "Error", MB_OK)
  End If

  Screen.MousePointer = 1
  ' Ah, protect the environment...  catch him in sport, and let 'im free.  :)
  ReleaseDC BFDEMO.hWnd, hdc

End Sub

Sub TT_Custom ()

  Dim TextEntered As String
  Dim SizeEntered As String
  Dim hdc%, i%, x%, y%, mypoints%, hfOld%, hMyFont%
  Dim bmf&, state&
  Dim logf As LOGFONT
  Dim logf2 As LOGFONT

  CustomForm.Show 1
  If CustomForm.Tag = "OK" Then
    TextEntered = CustomForm!TextBoxName
    SizeEntered = CustomForm!TextBoxSize
    mypoints = CInt(SizeEntered)
    i = 1
  End If
  Unload CustomForm
  If i <> 1 Then Exit Sub

  ' Get somewhere to draw to
  hdc = GetDC(BFDEMO.hWnd)
  If hdc = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't get an HDC.", "No HDC", MB_OK)
    Exit Sub
  End If
  state = bfSetBitMap(bfSTATE, hdc)
  Screen.MousePointer = 11
  BackgroundDraw hdc, 3
  
  x = BFDEMO.ScaleWidth / 2
  y = BFDEMO.ScaleHeight / 2

  ' Print the Loading message.
  If mypoints > 40 Then
    BackgroundDraw hdc, 3
    logf.lfHeight = -MulDiv(25, GetDeviceCaps(hdc, LOGPIXELSY), 72)
    logf.lfWidth = 0
    logf.lfWeight = FW_DONTCARE
    logf.lfFaceName = "Times New Roman" + Chr$(0)
    hMyFont = CreateFontIndirect(logf)
    If hMyFont <> 0 Then
      hfOld = SelectObject(hdc, hMyFont)
      i = TextOut(hdc, 50, 100, "Loading the TrueType font..", 27)
      hfOld = SelectObject(hdc, hfOld)
      i = DeleteObject(hMyFont)
    End If
  End If

  state = bfSetColors(bfSTATE, 0, 0, bfWHITE, bfBLACK, 1, bfBETA, bfGAMMA)
  state = bfSetDrawMode(bfSTATE, bfTRANS, 136)
  logf2.lfHeight = -MulDiv(mypoints * 4, GetDeviceCaps(hdc, LOGPIXELSY), 72)
  logf2.lfWidth = 0
  logf2.lfItalic = Chr(1)
  logf2.lfWeight = FW_DONTCARE
  logf2.lfFaceName = "Times New Roman" + Chr$(0)
  bmf = bfActOpenTT(hdc, logf2, "", bfBOTH)
  If bmf = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Couldnt open Large font", "Error", MB_OK)
  Else
    BackgroundDraw hdc, 1
    state = bfSetJust(bfSTATE, bfHCENTER, bfVCENTER)
    state = bfStrDraw(bfSTATE, x, y, TextEntered)
    state = bfSetJust(bfSTATE, bfHLEFT, bfVBASE)
    i = bfActClose(bmf)
  End If

  Screen.MousePointer = 1
  ' Ah, protect the environment...  catch him in sport, and let 'im free.  :)
  ReleaseDC BFDEMO.hWnd, hdc

End Sub

Sub TT_Large ()

  Dim hdc%, errval%, i%, mypoints%, hfOld%, hMyFont%
  Dim bmf&, state&
  Dim logf As LOGFONT
  Dim logf2 As LOGFONT
  
  ' Get somewhere to draw to
  hdc = GetDC(BFDEMO.hWnd)
  If hdc = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't get an HDC.", "No HDC", MB_OK)
    Exit Sub
  End If
  state = bfSetBitMap(bfSTATE, hdc)
  Screen.MousePointer = 11
  BackgroundDraw hdc, 3
  
  ' Print the Loading message.
  logf.lfHeight = -MulDiv(25, GetDeviceCaps(hdc, LOGPIXELSY), 72)
  logf.lfWidth = 0
  logf.lfWeight = FW_DONTCARE
  logf.lfFaceName = "Times New Roman" + Chr$(0)
  hMyFont = CreateFontIndirect(logf)
  If hMyFont <> 0 Then
    hfOld = SelectObject(hdc, hMyFont)
    i = TextOut(hdc, 50, 100, "Loading the large TrueType font..", 33)
    hfOld = SelectObject(hdc, hfOld)
    i = DeleteObject(hMyFont)
  End If

  state = bfSetColors(bfSTATE, 48, 0, bfWHITE, bfBLACK, 1, bfBETA, bfGAMMA)
  state = bfSetDrawMode(bfSTATE, bfBLEND, 0)

  ' Print the Large.
  mypoints = 180
  logf2.lfHeight = -MulDiv(mypoints * 4, GetDeviceCaps(hdc, LOGPIXELSY), 72)
  logf2.lfWidth = 0
  logf2.lfItalic = Chr(1)
  logf2.lfWeight = FW_DONTCARE
  logf2.lfFaceName = "Times New Roman" + Chr$(0)
  bmf = bfActOpenTT(hdc, logf2, "", bfBOTH)
  BackgroundDraw hdc, 1
  If bmf = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Couldnt open Large font", "Error", MB_OK)
  Else
    state = bfStrDraw(bfSTATE, 20, 300, "Large")
    i = bfActClose(bmf)
  End If

  Screen.MousePointer = 1
  ' Ah, protect the environment...  catch him in sport, and let 'im free.  :)
  ReleaseDC BFDEMO.hWnd, hdc

End Sub

Sub TT_RGB ()

  Dim hdc%, errval%, i%, mypoints%
  Dim bmf&, state&
  Dim logf As LOGFONT
  
  ' Get somewhere to draw to
  hdc = GetDC(BFDEMO.hWnd)
  If hdc = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't get an HDC.", "No HDC", MB_OK)
    Exit Sub
  End If
  state = bfSetBitMap(bfSTATE, hdc)
  Screen.MousePointer = 11
  BackgroundDraw hdc, 1
  
  ' Open font file
  i = APIGetObject(GetStockObject(SYSTEM_FONT), Len(logf), logf)
  mypoints = 32
  logf.lfHeight = -MulDiv(mypoints * 4, GetDeviceCaps(hdc, LOGPIXELSY), 72)
  logf.lfWidth = 0
  logf.lfWeight = FW_LIGHT
  logf.lfFaceName = "Times New Roman" + Chr$(0)
  bmf = bfActOpenTT(hdc, logf, "", bfBOTH)

  If bmf = 0 Then
    errval = bfGetError(bfCLEAR)
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't open the font file.", "Error = " + Str$(errval), MB_OK)
  Else
    state = bfSetFont(bfSTATE, bmf)
    state = bfSetDrawMode(bfSTATE, bfBLEND, 255)
    state = bfSetColors(bfSTATE, 0, 0, bfWHITE, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 170, 45, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfLIGHTGRAY, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 170, 80, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfGRAY, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 170, 115, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfDARKGRAY, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 170, 150, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfBLACK, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 170, 185, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfRED, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 170, 220, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfGREEN, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 170, 255, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfBLUE, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 170, 290, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfYELLOW, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 170, 325, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfCYAN, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 170, 360, "Text Line For Test!")
    state = bfSetColors(bfSTATE, 0, 0, bfPURPLE, bfWHITE, 1, bfBETA, bfGAMMA)
    state = bfStrDraw(bfSTATE, 170, 395, "Text Line For Test!")
    i = bfActClose(bmf)
  End If

End Sub

Sub TT_ShowAll ()

  Dim hdc%, errval%, i%, x%, y%
  Dim bmf&, state&
  Dim logf As LOGFONT

  ' Get somewhere to draw to
  hdc = GetDC(BFDEMO.hWnd)
  If hdc = 0 Then
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't get an HDC.", "No HDC", MB_OK)
    Exit Sub
  End If
  state = bfSetBitMap(bfSTATE, hdc)
  Screen.MousePointer = 11
  BackgroundDraw hdc, 4

  state = bfSetColors(bfSTATE, 48, 0, bfWHITE, &H404040, 1, bfBETA, bfGAMMA)
  state = bfSetDrawMode(bfSTATE, bfBLEND, 0)

  i = APIGetObject(GetStockObject(SYSTEM_FONT), Len(logf), logf)
  logf.lfHeight = -MulDiv(24 * 4, GetDeviceCaps(hdc, LOGPIXELSY), 72)
  logf.lfWidth = 0
  logf.lfWeight = FW_LIGHT
  logf.lfFaceName = "Times New Roman" + Chr$(0)
  bmf = bfActOpenTT(hdc, logf, "", bfBOTH)

  ' Draw the larger test font.
  If bmf = 0 Then
    errval = bfGetError(bfCLEAR)
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't open the font file.", "Error = " + Str$(errval), MB_OK)
  Else
    state = bfSetFont(bfSTATE, bmf)
    For y = 0 To 5
      bfGfxRect bfPUT, bfBACKSOLID, 0, bfBLACK, 0, 20, y * 34 + 32 - bfGetFontAscent(bmf), 620, y * 34 + 32 + bfGetFontDescent(bmf) - 1
      bfGfxLine &H404040, 0, 20, y * 34 + 32, 620, y * 34 + 32
      For x = 0 To 15
        state = bfChrDraw(bfSTATE, x * 34 + 32, y * 34 + 32, y * 16 + x + 32, 0)
      Next x
    Next y
    i = bfActClose(bmf)
  End If


  ' Draw the smaller test font.
  i = APIGetObject(GetStockObject(SYSTEM_FONT), Len(logf), logf)
  logf.lfHeight = -MulDiv(12 * 4, GetDeviceCaps(hdc, LOGPIXELSY), 72)
  logf.lfWidth = 0
  logf.lfWeight = FW_LIGHT
  logf.lfFaceName = "Times New Roman" + Chr$(0)
  bmf = bfActOpenTT(hdc, logf, "", bfBOTH)

  If bmf = 0 Then
    errval = bfGetError(bfCLEAR)
    i = MessageBox(BFDEMO.hWnd, "Sorry, can't open the font file.", "Error = " + Str$(errval), MB_OK)
  Else
    state = bfSetFont(bfSTATE, bmf)
    For y = 0 To 5
      bfGfxRect bfPUT, bfBACKSOLID, 0, bfBLACK, 0, 20, y * 34 + 32 - bfGetFontAscent(bmf) + 222, 620, y * 34 + 32 + bfGetFontDescent(bmf) - 1 + 222
      bfGfxLine &H404040, 0, 20, y * 34 + 32 + 222, 620, y * 34 + 32 + 222
      For x = 0 To 15
        state = bfChrDraw(bfSTATE, x * 34 + 32, y * 34 + 32 + 222, y * 16 + x + 32, 0)
      Next x
    Next y
    i = bfActClose(bmf)
  End If

  Screen.MousePointer = 1
  ' Ah, protect the environment...  catch him in sport, and let 'im free.  :)
  ReleaseDC BFDEMO.hWnd, hdc

End Sub

